【 POJ - 3126 】 D - Prime Path (BFS)

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

思路:

一开始用DFS,然后一直炸,只能改为BFS

根据BFS的特性,每次只走一步,限定了四位数(不能以0开头)

将四位数的个十百的数从0-9都尝试一次,千位数由于不能以0开头,所以从1-9尝试


代码:

#include <iostream>
#include <vector> 
#include <queue> 
using namespace std;
struct node{
	int v,step;
	node(int a,int b){v=a;step=b;}
};

int n,a,b;
bool p[10100]={false},vis[10100]={false}; //p标记素数,vis记录是否入队
	
int main() 
{
	for(int i=2;i<10000;i++)  //埃式筛 素数打表
	{
		if(!p[i])
		{
			for(int j=i*i;j<10000;j+=i)
			p[j]=1;
		} 		
	}
	
	cin>>n;
	while(n--)
	{
		cin>>a>>b;  //起始,目标
		queue<node> q;  //bfs
		q.push(node(a,0));
		fill(vis,vis+10000,0); //初始化
		int flag=0;  //标记是否找到目标
		while(!q.empty())
		{
			int u=q.front().v;
			int step=q.front().step;
			q.pop();
			vis[u]=1;
			if(u==b)  //到达目标,输出,结束后续操作
			{
				flag=1;
				cout<<step<<endl;
				break;
			}
			
			for(int i=0;i<=9;i++) //个位 
			{
				int v=u/10*10+i;
				if(!vis[v] && !p[v])
				{
					vis[v]=1;
					q.push(node(v,step+1));
				}
			}
			
			for(int i=0;i<=9;i++) //十位 
			{
				int v=u/100*100+i*10+u%10;
				if(!vis[v] && !p[v])
				{
					vis[v]=1;
					q.push(node(v,step+1));
				}
			}
			
			for(int i=0;i<=9;i++) //百位 
			{
				int v=u/1000*1000+i*100+u%100;
				if(!vis[v] && !p[v])
				{
					vis[v]=1;
					q.push(node(v,step+1));
				}
			}
			
			for(int i=1;i<=9;i++) //千位 
			{
				int v=i*1000+u%1000;
				if(!vis[v] && !p[v])
				{
					vis[v]=1;
					q.push(node(v,step+1));
				}
			}
		}
		if(!flag)  cout<<"Impossible"<<endl;
	}
	
   	return 0;
}
 

在这里插入图片描述

  • 1
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值